#!/bin/sh
#--------------------------------------------------------------
#
# phone.sh 
#
# Telefonnummern Suche V1.2a
#
# Aufruf übers Flexmenu:
#
# Dreambox:
#
# ACTION=&Telefonnummern Suche ,( /var/script/phone.sh makemainmenu ; if [ -f /tmp/phone_main.inc ] ; then /var/bin/shellexec /tmp/phone_main.inc ; rm /tmp/phone_* ; else msgbox popup='Fehler bei der Erstellung des Menus' timeout=5 ;fi )
#
# Dbox:
#
# ACTION=&Telefonnummern Suche,( /var/plugins/phone.sh makemainmenu ; if [ -f /tmp/phone_main.inc ] ; then /var/plugins/shellexec /tmp/phone_main.inc ; rm /tmp/phone_* ; else msgbox popup='Fehler bei der Erstellung des Menus' timeout=5 ;fi )
#
# V1.1 Auswahl und Suche fuer Ortsnamen eingebaut neue Quelle fuer PLZ und Ort Suche http://www.deutschland-adressen.de
#
# V1.2 Umlaute bei der Ortsuche geaendert, alle Umlaute durch Wildcard % ersetzt
#      da Suchanfragen mit oe,ue,ae leider nicht immer zu einem Ergebnis fuehren
#      Ausgabemoeglichkeite jetzt als reine Liste oder per Msgbox 
#      Stadtplanansicht des Wohnorts der gefundenen Personen, anzeigen falls vorhanden 
#      eigegeben Telefonnummer fuer die Laufzeit des Skripts zwischenspeichern 
#
# V1.2a URl fuer die Stadtplaene hat sich geaendert
#       alt: http://gy.live.blue24.com
#       neu: http://gy.orino.ch
#
# Author: barabas
#--------------------------------------------------------------
#set -x

#-------------------Boxtyp ermitteln Dreambox/DBox----------------------

boxtype=`uname -n`
[ $boxtype != "dreambox" -a $boxtype != "dm7020" ] && boxtype="dbox"

if [ $boxtype = "dbox" ] ; then

    # Pfad zur shellexec, tuxwetter und msgbox
    shellexec="/var/plugins/shellexec"
    msgbox="/var/bin/msgbox"
    input="/var/bin/input"
    tuxwetter="/var/plugins/tuxwet/tuxwetter"
    local_url="http://localhost"
    
else
  
    #  LD_LIBRARY_PATH setzen wegen libcurl Problem auf der Dreambox
    export LD_LIBRARY_PATH=/tmp:/var/lib:/lib:/var/bin/tuxwet
    
    #-----------------------------------------------------------------------
    # Dreambox HTTP User Authentifizierung User Passwort hier aendern
    # oder in der Datei pass.txt im Skriptverzeichnis hinterlegen
    #-----------------------------------------------------------------------
    scriptname=`basename $0`
    passfile=`echo $0 | sed "s:$scriptname:pass.txt:"`
    if [ -f $passfile ] ; then
      read auth <$passfile
    else
      auth="root:dreambox"
    fi

    # Pfad zur shellexec, tuxwetter und msgbox
    shellexec="/var/bin/shellexec"
    msgbox="/var/bin/msgbox"
    input="/var/bin/input"
    tuxwetter="/var/bin/tuxwet/tuxwetter"
    local_url="http://$auth@localhost/root"
  
fi

# Menutitel
menutitel="Telefonnummern Suche V1.2a"

# check echo Fehler busybox 
[ `echo "\r" | grep -c "\r"` -gt 0 ] && alias echo="echo -e"

# Steuerzeichen
TAB=`echo "\t"`
CRLF=`echo "\r"`
CR=`echo "\n"`

# Base Url
base_url="http://www.goyellow.de"
base_url_orte="http://www.deutschland-adressen.de"

# Adressdatei 
adressdatei=/var/tuxbox/config/phone_adresse.txt
# neu anlegen falls nicht vorhanden
if [ ! -s  $adressdatei ] ; then
 echo "plz:\nort:Mainz\nvorname:\nnachname:Klopp" >$adressdatei
fi

vorname="";nachname="";plz="";ort="";ortuml="";telnr="";ausgabe=""

# letzte Suche
letztesuchliste=/var/tuxbox/config/phone_letztesuche.txt
menumain=/tmp/phone_main.inc

# Fehlertexte
fehler_1="Es wurden keine Eintr.ge gefunden."
fehler_2="Der angegebene Ort wurde nicht gefunden."
fehler_3="Es wurden mehrere passende Orte gefunden"
fehler_4="Ihre Suchanfrage lieferte kein Ergebnis."
fehler_5="Wir haben deswegen <strong>in einem Umkreis von"
fehler_6="Wir haben stattdessen <strong>bundesweit"

#---------------------------------------------------------------------
# Timeout und Kill Funktion von rich aus dem Keywelt Board
# danke rich :-)
#---------------------------------------------------------------------
kill_function() {
	kill $$
	msgbox size=32 timeout=7 refresh=2 title="$menutitel" popup="~cTimeout:  Der Server ist nicht erreichbar !"
	exit 1
}
timeout() {
	sleep 30 && kill_function &
}

#------------------- Hauptmenu zusammenbauen ------------------

makemainmenu () {    

   echo "FONT=/share/fonts/micron_bold.ttf
      FONTSIZE=18
      LINESPP=11
      MENU=$menutitel
          MENU=Suche nach Name
            LINESPP=11
            ACTION=&Ort ~uber PLZ ermitteln, $0 plz_function
            ACTION=&Ort [A-Z] ausw~ahlen, $0 ort_auswahlmenu_function
            ACTION=&Ort eingeben / suchen, $0 ort_manuell_function
            ACTION=&Name eingeben und Tel. suchen, $0 name_function
            INCLUDE="/tmp/phone_info.inc"
            INCLUDE="/tmp/phone_space.inc"
            COMMENT=*
            COMMENT=Quelle: (c) GoYellow.de
          ENDMENU
          ACTION=&Suche nach Telefonnummer, $0 tel_function
        DEPENDON=&Letztes Suchergebnis anzeigen, $0 letztesuche $letztesuchliste,$letztesuchliste
         INCLUDE="/tmp/phone_info.inc"
         INCLUDE="/tmp/phone_space.inc"
         COMMENT=
         COMMENT=*
         COMMENT=Quelle: (c) GoYellow.de
      ENDMENU" >$menumain
          
  }

# --------------------- Infozeile ----------------------------
infozeile_function () {

  # altes Info Menu loeschen, Leerzeilen Includedatei erzeugen
  [ -s /tmp/phone_info.inc ]&& rm /tmp/phone_info.inc
  
  # gespeicherte Daten einlesen
  read_adress_function
  echo "COMMENT=*\nCOMMENT=Vorname: $vorname\nCOMMENT=Nachname: $nachname\nCOMMENT=PLZ: $plz\nCOMMENT=Ort: `echo $ort | sed 's/+/ /g'`" >/tmp/phone_space.inc

 }
 
# ------------- Adressdaten einlesen --------------------------------

read_adress_function () {

    plz=`sed -e '/plz:/!d' -e 's/plz://' $adressdatei`
    ort=`sed -e '/ort:/!d' -e 's/ort://' $adressdatei`
    vorname=`sed -e '/vorname:/!d' -e 's/vorname://' $adressdatei`
    nachname=`sed -e '/nachname:/!d' -e 's/nachname://' $adressdatei`

    
}
 
# ----------------- PLZ eingeben -----------------------------

plz_function () {


        # PLZ aus Konfigfile ermitteln
        def=`sed -e '/plz:/!d' -e 's/plz://' $adressdatei`
        
        [ "$def" = "" ] && def="_"
          
        # neue PLZ eingeben
        plz=`$input l='#####' d="$def" t="PLZ eingeben"`
        
        if [ `echo "$plz" | grep -c '[0-9]'` -eq 0 ] ; then return 1 ; fi
   
    
    # PLZ speichern
    sed -i "s/plz:.*$/plz:$plz/" $adressdatei
    
    # Ort zur PLZ ermitteln   
    ort=`ort_plz_function $plz`
    [ $? = "1" ] && return 1
    
     # Ort abspeichern
     [ "$ort" != "" ] && sed -i "s@ort:.*@ort:$ort@" $adressdatei     
                    
    # aktualisieren
    infozeile_function 

}

# --------------- Ort manuell eingeben --------------------------

ort_manuell_function () {
                   
 
    # Ort aus Konfigfile ermitteln
    def=`sed -e '/ort:/!d' -e 's/ort://' $adressdatei`
  
    [ "$def" = "" ] && def="_"
  
    ort=`$input l='@@@@@@@@@@@@@@@@@@@@@@@@@' d="$def" t="Ort eingeben" c=25 k=1`
  
    if [ `echo "$ort" | grep -c '[A-Za-z]'` -eq 0 ] ; then return 1 ; fi
        
    if [ "$ort" != "" ] ; then
    
       # falls Umlaute verwendet wurden werden diese in der inputbox autom. umgewandelt
       # deshalb hier wieder tauschen
       ort="`echo $ort | sed 's/ /+/g;s/~a/ae/g;s/~o/oe/g;s/~u/ue/g;s/~A/Ae/g;s/~O/Oe/g;s/~U/Ue/g;s/~z/ss/g'`" 
       
       # fuer die Ortssuche haut das mit den Umlauten leider nicht so recht hin
       # mal werden Orte unter Angabe der Umlaute oe ae ue gefunden und mal 
       # wieder um nicht z.b. Überlingen. 
       # Da arbeitet die Suchengine von Deutschland-Adressen.de wohl nicht so optimal....
       # deshalb hier die Umlaute durch den Wildcard %25 ersetzen
       ortuml="`echo $ort | sed 's/ae/%25/g;s/oe/%25/g;s/ue/%25/g;s/Ae/%25/g;s/Oe/%25/g;s/Ue/%25/g'`" 
 
 
       $msgbox title="$menutitel" msg="Ort ~Y$ort~S ~ubernehmen~noder alle Orte mit: ~Y$ort~S suchen?" select="~Ubernehmen,Suchen"
       case $? in
         1) # PLZ loeschen
            plz="" ; sed -i "s/plz:.*$/plz:$plz/" $adressdatei
            ;;
         2) ort_suchen_function "$ortuml" 
            ;;
       
       esac 
  
        # Ort abspeichern
        sed -i "s@ort:.*@ort:$ort@" $adressdatei
            
        # aktualisieren
        infozeile_function 
    
    fi 
}

# ----------------- Ort suchen -----------------------------------------

ort_suchen_function () {
 
    ortuml="$1"
       
    timeout
    wget -O- "http://www.deutschland-adressen.de/suchergebnis.php?ort=$ortuml&plz=&kfz=&AdvSearch=AdvSearch&submit=Suchen%21" > /tmp/phone_orte_manuell_auswahl.inc 
    kill $!
    
    ort_auswahl_function manuell

   }
# ----------------- Ort ueber PLZ ermitteln -----------------------------

ort_plz_function () {

    plz=$1
    
    # Suche ueber Deutschland Adressen
    # http://www.deutschland-adressen.de/suchergebnis.php?ort=&plz=$plz&kfz=&AdvSearch=AdvSearch&submit=Suchen%21
    
    # Suche ueber Postleitzahlen.org
    # http://www.postleitzahl.org/suche.html?type=plz&string=$plz&submit=Finde
    
    [ -s  /tmp/phone_ortauswahl.txt ] && rm  /tmp/phone_ortauswahl.txt
    
    # ueber Deutschland Adressen
    wget -O- "http://www.deutschland-adressen.de/suchergebnis.php?ort=&plz=$plz&kfz=&AdvSearch=AdvSearch&submit=Suchen%21" | sed "s/$CRLF//g" |\
         
    sed -e '/<a href=\"Ort-/!d' -e 's/<[^>]*>/@/g' -e 's/@*/@/g' -e 's/@$//g' -e 's/^@//g' -e "s/^@$TAB*@//g" >/tmp/phone_plz_abfrage.txt
    
    # Ergebnis sieht jetzt z.b. so aus:
    # Stuttgart@Stadtkreis@Baden-Wuerttemberg
    
    
    # Ueber Postleitzahlen.org
    #wget -O- "http://www.postleitzahl.org/suche.html?type=plz&string=$plz&submit=Finde" | sed "s/$CRLF//g" |\   
    #sed -e '/<td valign="top"><b><a href="/!d' -e 's/<[^>]*>/@/g' -e 's/@*/@/g' -e 's/@$//g' -e "s/^@$TAB*@//g" >/tmp/phone_plz_abfrage.txt
    
    # Ergebnis sieht jetzt z.b. so aus:
    # Stuttgart@in Baden Württemberg
    # Zuffenhausen@in Baden Württemberg
    # Weilimdorf@in Baden Württemberg
    # Wolfbusch@in Baden Württemberg
    
    if [ ! -s /tmp/phone_plz_abfrage.txt ] ; then
      
      $msgbox title="Achtung!" msg="Keine St~adte gefunden f~ur PLZ: $plz" timeout=5 >/dev/null 2>&1
      return 1
      
    else
      
       # Ort anzeigen und auswaehlen uebers Flexmenu
       echo "FONT=/share/fonts/micron_bold.ttf
             FONTSIZE=18
             LINESPP=11
             MENU=Ort ausw~ahlen f~ur PLZ: $plz" >/tmp/phone_orte.inc
             
       # Ausgabe fuer Postleitzahlen.org
       #sed 's:\(^.*\)@\(.*$\):ACTION=\1,echo \"\1\" >/tmp/phone_ortauswahl.txt:g' /tmp/phone_plz_abfrage.txt >>/tmp/phone_orte.inc
       
       # Ausgabe fuer Deutschland Adressen 
       sed 's:\(^.*\)@\(.*\)@\(.*$\):ACTION=\1,echo \"\1\" >/tmp/phone_ortauswahl.txt:g' /tmp/phone_plz_abfrage.txt >>/tmp/phone_orte.inc
            
       echo "ENDMENU" >>/tmp/phone_orte.inc
      
       # Orte anzeigen
       $shellexec /tmp/phone_orte.inc >/dev/null 2>&1
       
       # gewaehlten Ort zurueckgeben 
       if [ -s  /tmp/phone_ortauswahl.txt ] ; then
         cat /tmp/phone_ortauswahl.txt
       else
         return 1
       fi
       
    fi
    

}

# -------------------- Ort auswaehlen ---------------------------

ort_auswahlmenu_function () {

    
# Menukopf fuer Ort Auswahl
   echo "FONT=/share/fonts/micron_bold.ttf
      FONTSIZE=18
      LINESPP=11
      MENU=Orte von A - Z" >/tmp/phone_orte_auswahl.inc

x=0      
for char in A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
do

 echo "ACTION=&Orte mit Anfangsbuchstabe: $char, $0 ort_auswahl_function $char"
 
 x=`expr $x + 1`
 if [ $x -eq 9 ] ; then
   echo "COMMENT=*"
   echo "COMMENT=(c) www.deutschland-adressen.de"
   x=0
 fi

done >>/tmp/phone_orte_auswahl.inc

# Restliche Menuzeilen auffuellen
while [ $x -lt 9 ]
do
 echo "COMMENT="
 x=`expr $x + 1`
done >>/tmp/phone_orte_auswahl.inc

echo "COMMENT=*" >>/tmp/phone_orte_auswahl.inc
echo "COMMENT=(c) www.deutschland-adressen.de" >>/tmp/phone_orte_auswahl.inc
echo "ENDMENU" >>/tmp/phone_orte_auswahl.inc

$shellexec /tmp/phone_orte_auswahl.inc 


}

# -------------------------- Ort aus Menu auswaehlen -------------------

ort_auswahl_function () {

   char=$1
   
   if [ $char != "manuell" ] ; then
   
     # PID Auswahlmenu ermitteln fuer kill am ende
     pid_auswahlmenu=`ps | sed -e '/shellexec \/tmp\/phone_orte_auswahl.inc/!d' -e s'/ [a-z].*$//'` 
     url=$base_url_orte/OAZ_0_$char.php
     string="Orte mit Anfangsbuchstabe: $char"
     
   else   
     
     [ -s /tmp/phone_orte_${char}_auswahl.inc ] && rm /tmp/phone_orte_${char}_auswahl.inc
     url="$base_url_orte/suchergebnis.php?ort=$ortuml&plz=&kfz=&AdvSearch=AdvSearch&submit=Suchen%21"
     string="Orte mit Teilstring: `echo $ort | sed 's/+/ /g'`"
     
   fi

   if [ ! -s /tmp/phone_orte_${char}_auswahl.inc ] ; then
  
        # alle Seiten ermitteln 
        # dazu Anzahle der Seiten pro Anfangsbuchstabe ermitteln und alle Seiten einlesen
        if [ $char != "manuell" ] ; then
     
         last=`wget -O- $url | sed -e '/Letzter/!d;s/^.*OAZ_//;s/_.*$//' | sed -e'1!d'`
     
        else
           
         last=`wget -O- $url | sed -e '/Letzter/!d;s/^.*_ausgabe=//;s/\&ort=.*$//' | sed -e'1!d'`
                  
         if [ $last -gt 10 ] ; then
            $msgbox titel=$menutitel msg="Es wurden $last Orte gefunden.~nAlle anzeigen?" select="Ja,Nein"
            case $? in
              1) return 0 ;;
              2) return 1 ;;
            esac 
          fi
          
        fi 
     
        [ "$last" = "" ] && last=0
        
        #$msgbox msg="$last PID: $pid_auswahlmenu"
        
        # Menukopf fuer Ort Auswahl
           echo "FONT=/share/fonts/micron_bold.ttf
              FONTSIZE=18
              LINESPP=10
              MENU=$string" >/tmp/phone_orte_${char}_auswahl.inc
              
        seite=0
        
        while [ $seite -le $last ] ; do
        
          if [ $last -gt 0 ] ; then
            case $seite in
             0|5|10|15|20|25|30|35|40|45|50|55|60) $msgbox title="$menutitel" popup="Bearbeite Seite: $seite von $last" timeout=1 refresh=0 &     
                                                    pidmes=$! ;;
             esac                                    
          fi
           
           if [ $char != "manuell" ] ; then
           
             url="$base_url_orte/OAZ_${seite}_${char}.php"
           
           else
           
             if [ $last -eq 0 ] ; then
               url="$base_url_orte/suchergebnis.php?ort=$ortuml&plz=&kfz=&AdvSearch=AdvSearch&submit=Suchen%21"
             else
               url="$base_url_orte/suchergebnis.php?pageNum_ausgabe=$seite&totalRows_ausgabe=126&ort=$ortuml&plz=&kfz=&AdvSearch=AdvSearch&submit=Suchen%21"
             fi
             
           fi
             
           wget -O- $url |\
           
           sed '/<strong>KFZ<\/strong>/,/Letzter/!d' |\
     
           # alle Ortsangaben in eine Zeile und nur diese Zeilen in Menu ausgeben
           sed -e :a -e '/<\/td>$/N; s/\n//; ta' |\
           
           sed -e "s#<a href=\"Ort-#$base_url_orte/Ort-#" -e 's/php\">/php@/g' |\
           
           # http://www.deutschland-adressen.de/Ort-26516.php@Utersum@Schleswig-Holstein@Nordfriesland@NF@
           # @Postleitzahl:@ @16909@Bundesland:@ @Brandenburg@Landkreis:@ @Ostprignitz-Ruppin@Verwaltung:@ @Amt Heiligengrabe/Blumenthal@KFZ-Kennzeichen:@ @OPR@
           
           sed -e '/<td class=\"border_u\">/!d' -e 's/<[^>]*>/@/g' -e 's/@*/@/g' -e 's/^@//g' -e "s#\(^.*\)@\(.*\)@\(.*\)@\(.*\)@\(.*\)@\(.*$\)#ACTION=\2, plz=\`wget -O- '\1' | sed -e '/Postleitzahl:/!d' -e 's/<[^>]*>/@/g' -e 's/@*/@/g' -e 's/^@Postleitzahl:@ @//' -e 's/@Bundesland.*//g'\` ; [ \`echo \"\$plz\" | grep -c ','\` -gt 0 ] \&\& plz=\"\" ; ort=\`echo '\2' | sed -e 's/[ \/]/+/g'\` ; sed -i \"s@ort:.*@ort:\$ort@\" $adressdatei ; sed -i \"s@plz:.*@plz:\$plz@\" $adressdatei\nCOMMENT=\3 - \4#"
           
           seite=`expr $seite + 1`
           
        done >>/tmp/phone_orte_${char}_auswahl.inc
        
        echo "ENDMENU" >>/tmp/phone_orte_${char}_auswahl.inc
        
        kill -9 $pidmes
    
    fi
    
    $shellexec /tmp/phone_orte_${char}_auswahl.inc

    #plz="" 
    # PLZ loeschen
    #sed -i "s/plz:.*$/plz:$plz/" $adressdatei

    # aktualisieren
    infozeile_function 
     
    # Ort Vorauswahlmenu automatisch beeenden 
    [ $char != "manuell" ] && kill -15 $pid_auswahlmenu
          
          
   }
   
# -------------------- Name eingeben ----------------------------

name_function () {

    # Namen aus Konfigfile ermitteln
    def_1=`sed -e '/vorname:/!d' -e 's/vorname://' $adressdatei`
    def_2=`sed -e '/nachname:/!d' -e 's/nachname://' $adressdatei`
    
    def="$def_1 $def_2"
    
    [ "$def" = "" ] && def="_"
    
    name=`$input l='@@@@@@@@@@@@@@@@@@@@@@@@@' d="$def" t='[Vorname] Nachname eingeben' k=1 c=25`
    if [ `echo "$name" | grep -c '[0-9a-zA-Z]'` -eq 0 ] ; then return 1 ; fi
    
    #nachfolgende Leerzeichen loeschen
    name=`echo "$name" | sed 's/ *$//'`
    
    vorname=${name%% *}
    nachname=${name##* }
     
    # nur Nachname eingegeben
    if [ "$nachname" = "$vorname" ] ; then
     nachname="$vorname" ; vorname=""
    fi
  
    # falls Umlaute verwendet wurden werden diese in der inputbox autom. umgewandelt
    # deshalb hier wieder tauschen
    vorname=`echo $vorname | sed 's/~a/ae/g;s/~o/oe/g;s/~u/ue/g;s/~A/Ae/g;s/~O/Oe/g;s/~U/Ue/g;s/~z/ss/g'`
    nachname=`echo $nachname | sed 's/~a/ae/g;s/~o/oe/g;s/~u/ue/g;s/~A/Ae/g;s/~O/Oe/g;s/~U/Ue/g;s/~z/ss/g'`
    
    # Name speichern
    sed -i "s/vorname:.*$/vorname:$vorname/" $adressdatei
    sed -i "s/nachname:.*$/nachname:$nachname/" $adressdatei
    
    # aktualisieren
    infozeile_function 
     
  }
  

# ----------------------- Eintraege suchen -------------------
 
suche_function () {

    plz="$1" ; ort="$2" ; vorname="$3" ; nachname="$4"
  
    # Detailsuche
    # such_url="http://www.goyellow.de/detailsuche/?ACTION=search&SUBACTION=search&keywords=&BCP=&GIV=$vorname&NAM=$nachname&PRO=&STR=&HNO=&ZCD=$plz&LOC=$ort" 
      
    # nur privat Eintraege ; wenn keine PLZ angegeben ist dann LFLT=1 setzen
    #if [ "$plz" = "" ] ; then
    #  lflt=1
    #else
    #  lflt=1
    #fi
    
    #such_url="http://www.goyellow.de/detailsuche/?PRO=&NAM=$nachname&GIV=$vorname&LOC=$ort&STR=&HNO=&DIS=&ZCD=$plz&LFLT=$lflt&BCP=private+Eintr%E4ge"
 
    
    # Schnellsuche
    # such_url="http://www.goyellow.de/schnellsuche/?MDN=$vorname+$nachname&LOC=$plz+$ort&BCP=private+Eintr%E4ge" 
    
    such_url="http://www.goyellow.de/schnellsuche/?MDN=$vorname+$nachname&LOC=$plz+$ort&BCP=private+Eintr%E4ge"
    
    echo $such_url >/tmp/phone_suchurl.tmp
    
    timeout
    wget -O- "$such_url" >/tmp/phone_out.html
    kill $!
    
    if [ `grep -c "$fehler_1" /tmp/phone_out.html` -gt 0 ] ; then
    
      ausgabe="~nKeine Eintr~age gefunden f~ur:~n~nVorname: $vorname~nNachname: $nachname~n~nOder die Ortsangabe ist nicht eindeutigt:~n~nPLZ: $plz Ort: $ort"
      $msgbox title="$menutitel" msg="$ausgabe" timeout=10
      return 1
    
    fi
    if [ `grep -c "$fehler_2" /tmp/phone_out.html` -gt 0 ] ; then
    
      $msgbox title="$menutitel" msg="~n$fehler_2" timeout=10
      return 1
    
    fi
   
       
    # Anzahl ermitteln
    treffer=`sed -e '/<div class="hits">/!d' -e 's/<div class="hits">//' -e 's/ Treffer.*$//' /tmp/phone_out.html`
    
    # Kein passender Eintrag fuer Name in Ort gefunden -> Bundesweit oder Umkreissuche wurde durchgefuehrt
    umkreis=`grep -c "$fehler_5" /tmp/phone_out.html`
    bundesweit=`grep -c "$fehler_6" /tmp/phone_out.html`
    
    if [ $treffer -gt 10 -o $umkreis -gt 0 -o $bundesweit -gt 0 ] ; then   
     
      if [ $umkreis -gt 0 ] ; then
        
        msg="~nKeine Eintr~age gefunden f~ur:~n~nVorname:~T240~Y$vorname~S~nNachname:~T240~Y$nachname~S~nPLZ:~T240~Y$plz~S~nOrt:~T240~Y`echo $ort | sed 's/+/ /g'`~S~n~n~s~n~nEine Umkreissuche wurde durchgef~uhrt~nhierbei wurden ~Y$treffer~S Treffer gefunden.~n~nAlle anzeigen?" timeout=10
      
      else
       
        if [ $bundesweit -gt 0 ] ; then
          msg="~nKeine Eintr~age gefunden f~ur:~n~nVorname:~T240~Y$vorname~S~nNachname:~T240~Y$nachname~S~nPLZ:~T240~Y$plz~S~nOrt:~T240~Y`echo $ort | sed 's/+/ /g'`~S~n~n~s~n~nEine bundesweite Suche wurde durchgef~uhrt~nhierbei wurden ~Y$treffer~S Treffer gefunden.~n~nAlle anzeigen?" timeout=10      
        else 
           msg="Es wurden ~Y$treffer~S Treffer gefunden f~ur:~n~n~tVorname:~T240~Y$vorname~S~n~tNachname:~T240~Y$nachname~S~n~tPLZ:~T240~Y$plz~S~n~tOrt:~T240~Y`echo $ort | sed 's/+/ /g'`~S~n~nAlle anzeigen?"
        fi
      
      fi
      
      $msgbox title="$menutitel" size=30 msg="$msg" select="Ja,Nein"
 
      case $? in
         1) return 0 ;;
         2) return 1 ;;
      esac 
      
    else
    
      return 0
    
    fi
         

  }
 
# ----------------------- Suche nach Telefonnummer ------------------------

tel_function () {
                     
          # falls vorhanden gespeicherter Tel.nr als Defaultwert setzen
          if [ -s /tmp/phone_telnr.txt ] ; then
            def=`cat /tmp/phone_telnr.txt`
          else
            def="0"
          fi
          
          telnr=`$input l='################' d="$def" t='Telefonnummer eingeben' k=0`
          
          if [ `echo "$telnr" | grep -c '[0-9]'` -eq 0 ] ; then return 1 ; fi     
          
          echo "$telnr" >/tmp/phone_telnr.txt
          
          such_url="$base_url/inverssuche/?TEL=$telnr"
          
          timeout
          wget -O- "$such_url" >/tmp/phone_out.html
          kill $!
          
          if [ ! -s /tmp/phone_out.html ] ; then    
            $msgbox title="$menutitel" msg="Fehler bei der Ermittlung" timeout=10
            return 1
          fi
           
          if [ `grep -c "$fehler_1" /tmp/phone_out.html` -gt 0 ] ; then
    
            ausgabe="~nKeine Eintr~age gefunden f~ur:~n~nTel: ~Y$telnr~S"
            $msgbox title="$menutitel" msg="$ausgabe" timeout=10
            return 1
    
          fi
          
          # Auswertung durchfuehren
          auswertung_function
          
          # erste Zeile loeschen
          sed -i '1d' /tmp/phone_out.txt
                    
  }
     
# -------------------- Treffer ermitteln -------------------------

treffer_function () {
    
    # beim mehr als einer Trefferseite , letzte Seite ermitteln und alle Seiten einlesen
       
    # Ausgabe der Zeile direkt unterhalb von '<div class="bullet end">'
    # bei mehreren Seiten steht da die letzte Seite:
    # <a href="/detailsuche/mayer/?GIV=&amp;LOC=Mainz&STR=&HNO=&DIS=&ZCD=&PNO=12:711367&LFLT=0" onclick="return goUtils.loadURL('/detailsuche/?PRO=&amp;NAM=Mayer&amp;GIV=&amp;LOC=Mainz&amp;STR=&amp;HNO=&amp;DIS=&amp;ZCD=&amp;PNO=12:711367&amp;LFLT=1');&#10;&#9;&#9;&#9;" title="Zum Ende des Ergebnisses" rel="nofollow">
    # bei nur einer Seite:
    # <img border="0" src="/images/common/btn_bulletGrey_end.gif" />
      
    letzteseite=`sed -n '/<div class="bullet end">/{n;p;}'  /tmp/phone_out.html`
    
    if [ `echo "$letzteseite" | grep -c 'PNO='` -gt 0 ] ; then
    
      letzteseiten_nr=`echo "$letzteseite" | sed -e 's/^.*PNO=//' -e 's/[:&].*$//'`
      seite_url=`echo "$letzteseite" | sed  -e "s#<a href=\"#$base_url#" -e 's/" onclick.*$//' -e 's/amp;//g'`
      x=0
      while [ $x -le $letzteseiten_nr ] ; do
         
        seite_url=`echo "$seite_url" | sed "s#PNO=.*#PNO=$x#"`
        
        $msgbox title="$menutitel" popup="Bearbeite Seite $x von $letzteseiten_nr" refresh=0 timeout=2 &
        
        timeout
        wget -O- "$seite_url" >/tmp/phone_out.html
        kill $!
        
        auswertung_function 
            
        x=`expr $x + 1`
      
      done   
    
    else

      # nur eine Treffer Seite dann direkt zur Auswertung
      auswertung_function 
      
    fi
    
    # erste Zeile loeschen
    sed -i '1d' /tmp/phone_out.txt
   
   }

# ----------------------- Auswertung der Trefferseiten -------------------------

auswertung_function () {

   # nur den Bereich zw. listing und hits bearbeiten 
   sed '/<div id="listing">/,/<div class="hits">/!d' /tmp/phone_out.html |\
  
   # und in dem Bereich nur die relvanten Zeilen bearbeiten
   sed -e '/<div class="head">/b' -e '/title="Detailinformationen zu/b' -e '/nachnr=0/b' -e '/rel="nofollow">[0-9]/b' -e '/^<h3>.*<\/h3>$/b' -e '/Stadtplan/b' -e '/<p class="address">/!d' |\
  
   sed -e "/Stadtplan/s@<a href=\"/upgrade@$base_url/upgrade@" -e 's/#map.*$/#map/g' |\
  
   # Trenner zw. Eintrag setzen
   sed -e 's/<div class="head">/Next/g' -e 's/<[^>]*>/ /g' >>/tmp/phone_out.txt
             
}

# ----------------------- Anzeige Liste/Einzeln Abfrage -------------------------

abfrage_function () {

    datei=$1
    typ=$2

    # bei Suche nach einer Telefonnummer Einzelausgabe ohne Abfrage
    if [ "$typ" = "Nummernsuche" ] ; then
      ausgabe="Einzeln"
    else  
      ausgabe=`$msgbox title="$menutitel" size=30 msg="Ausgabe der gefundenen Eintr~age als:~n~s~n~nListe mit TuxWetter~n~nEinzeln per MsgBox und mit Stadtplananzeige~n" echo=1 select="Liste,Einzeln"`
    fi
    
    case $ausgabe in
    
    "Liste") # URL zum Stadtplan entfernen
             sed '/^http:/d' $datei >/tmp/phone_out_liste.txt
             # Trennzeile fuer Listendarstellung einfuegen
             sed -i 's/Next/-------------------------------------------------------------/g' /tmp/phone_out_liste.txt           
             $tuxwetter "TXTPLAIN=Liste,$local_url/tmp/phone_out_liste.txt"           
             ;;
    
  "Einzeln") # falls Letzte Zeile nicht Next enthaelt -> Next anhaengen
             [ `sed '$!d' $datei | grep -c "Next"` -eq 0 ] && echo "Next" >>$datei
             
             anz_eintraege=`grep -c "Next" $datei`
                           
             button="" ; msg="" ; def=1
             while read line ; do
                
                case "$line" in
                
                 *http*) button="Stadtplan anzeigen"
                         grafikurl="$line"                       
                         ;;
                 
                   Next) if [ "$typ" = "Nummernsuche" -o $anz_eintraege -eq 1 ] ; then
                            button="Ende,$button"                          
                         else
                            button="Weiter,Abbruch,$button" 
                         fi
                                             
                         anz_eintraege=`expr $anz_eintraege - 1`
                                                   
                         erg=`$msgbox title="$menutitel" msg="$msg" default=$def absolute=1 echo=1 select="$button"`
                                   
                         case "$erg" in
                         Stadt*) zielgrafik_url=`wget -O- "$grafikurl" | sed -e '/map.jpg/!d' -e 's/^.*src="//' -e 's/".*border=.*$//' -e 's/amp;//g'`
                                
                                # Zielgrafik anzeigen  
                                # ueber die URL aus der HTML Seite:
                                # http://www.goyellow.de/map.jpg/?long=9.12445&lat=48.88606&w=556&h=500&z=17&circle=1&lyrs=XsF3QMEVZkw!%2CXoAqA3wiltj%2CLd9PjW9%2BHv!%2C7ZMffVpVbz%2CMIV16ngraV!%2CDF_d_xbjiu%2CXaUSzbIE4yt!%2CXQiae9RgJD_%2CL4As4j5irI!%2C5B1AqynV7L%2CXSbu14H_1oJ!%2CXsMB2hTBRdT%2CpzN0%2BWgV1x!%2CX0qj4h5wQM%2CLDcXd%2BRAtX!%2CB1bCAOpsor%2CjvFN3EAVD2!%2C5hKzZlgGBG%2CAuK_Idz6R7!%2CB8JToawHXU%2CybqHSIVLNg!%2CgAt9K06%2Bl5%2CPRu9j4u8oJ!%2CuLY_80AfvJ%2CXC_fXEWr3Xn!%2CX9m3vM06XY_%2CFReBplFIpB!%2CLKtJkS8wCX%2CXe7chqNAfIp!%2CXH2e8SXUiJ7%2CW6tu1UN0D4!%2Cr7WDrtZBwj%2CfZiSXcooIB!%2CkGm0j_URbw%2CSM%2BtUYOfmt!%2Cw4igp7QaSO%2CCRJSZP9EPz%2CUx4h9_0wPW&mt=1&circle=1" border="0"
                                # wird dynamisch verlinkt nach:
                                # http://gy.live.blue24.com/srv/map.php?addr=9.12445%2C48.88606&z=17&w=720&h=576&lyrs=XsF3QMEVZkw%21%2CXoAqA3wiltj%2CLd9PjW9%2BHv%21%2C7ZMffVpVbz%2CMIV16ngraV%21%2CDF_d_xbjiu%2CXaUSzbIE4yt%21%2CXQiae9RgJD_%2CL4As4j5irI%21%2C5B1AqynV7L%2CXSbu14H_1oJ%21%2CXsMB2hTBRdT%2CpzN0%2BWgV1x%21%2CX0qj4h5wQM%2CLDcXd%2BRAtX%21%2CB1bCAOpsor%2CjvFN3EAVD2%21%2C5hKzZlgGBG%2CAuK_Idz6R7%21%2CB8JToawHXU%2CybqHSIVLNg%21%2CgAt9K06%2Bl5%2CPRu9j4u8oJ%21%2CuLY_80AfvJ%2CXC_fXEWr3Xn%21%2CX9m3vM06XY_%2CFReBplFIpB%21%2CLKtJkS8wCX%2CXe7chqNAfIp%21%2CXH2e8SXUiJ7%2CW6tu1UN0D4%21%2Cr7WDrtZBwj%2CfZiSXcooIB%21%2CkGm0j_URbw%2CSM%2BtUYOfmt%21%2Cw4igp7QaSO%2CCRJSZP9EPz%2CUx4h9_0wPW&comp=bg%2Cfg%2Ccircle&mt=aerial&outformat=jpg

                                # neu 18.04.2007:
                                # http://gy.orino.ch/srv/map.php?addr=8.26229%2C50.00832&z=17&mt=1&w=556&h=500&lyrs=&comp=bg%2Cfg%2Ccircle&mt=aerial&outformat=jpg

                                # deshalb aus der Quell-URL folgende Angaben uebernehmen:
                                # long und lat Koordinate, z fuer den Zoomfaktor (17 = Standard, 18 weiter rein falls moeglich 16 weiter raus)
                                # und die SessionID ? lyrs
                                
                                long=`echo "$zielgrafik_url" | sed -e 's/^.*long=//' -e 's/\&lat=.*$//'`
                                lat=`echo "$zielgrafik_url" | sed -e 's/^.*lat=//' -e 's/\&w=.*$//'`
                                zoom=`echo "$zielgrafik_url" | sed -e 's/^.*\&z=//' -e 's/\&circle.*$//'`
                                # lyrs wird nicht benoetigt , sorry SnowHead :-)
                                #lyrs=`echo "$zielgrafik_url" | sed -e 's/^.*lyrs=//' -e 's/\&mt=.*$//'`
                                lyrs=""
                                
                                # w=556 h=550
                                ausgabe_grafik_url="http://gy.orino.ch/srv/map.php?addr=$long%2C$lat&z=$zoom&w=556&h=500&lyrs=$lyrs&comp=bg%2Cfg%2Ccircle&mt=aerial&outformat=jpg"
                                
                               echo $zielgrafik_url >/tmp/ttt
                               echo $long >>/tmp/ttt
                               echo $lat >>/tmp/ttt
                               echo $zoom >>/tmp/ttt
#                               echo $lyrs >>/tmp/ttt
                               echo $ausgabe_grafik_url >>/tmp/ttt
                                
                                 # Tuxwetter Config zusammenbauen 
                                 echo "SplashScreen=0\nSystemColors=1\nMENU=Stadtplan anzeigen" >/tmp/phone_tuxwetter.conf
                                 echo "PICTURE=Stadtplan Zoomstufe 18,|JPG|$ausgabe_grafik_url" | sed 's/z=17/z=18/' >>/tmp/phone_tuxwetter.conf
                                 echo "PICTURE=Stadtplan Zoomstufe 17,|JPG|$ausgabe_grafik_url" >>/tmp/phone_tuxwetter.conf
                                 echo "PICTURE=Stadtplan Zoomstufe 16,|JPG|$ausgabe_grafik_url" | sed 's/z=17/z=16/' >>/tmp/phone_tuxwetter.conf
                                 echo "PICTURE=Stadtplan Zoomstufe 15,|JPG|$ausgabe_grafik_url" | sed 's/z=17/z=15/' >>/tmp/phone_tuxwetter.conf
                                 #echo "PICTURE=Stadtplan Zoomstufe 19,|JPG|$ausgabe_grafik_url" | sed 's/z=17/z=19/' >>/tmp/phone_tuxwetter.conf
                                 echo "ENDMENU" >>/tmp/phone_tuxwetter.conf
                                 $tuxwetter /tmp/phone_tuxwetter.conf
                                
                                 #$tuxwetter "PICTURE=Zielgrafik Zoomstufe 0,|JPG|$ausgabe_grafik_url" 
                                ;;
                              
                          Ende) return 1
                                ;;
                       Abbruch) return 1
                                ;;
                                          
                         esac    
                         button="" ; msg="" ; def=1
                         ;;    
                 
                      *) msg="$msg $line~n~n"
                        ;;                        
                esac     
             
             done < $datei
             ;;
     esac
    
}

# ---------------------- Main ---------------------------------------


case "$1" in
        
             makemainmenu) infozeile_function ; makemainmenu
                           ;;
                           
             plz_function) plz_function 
                           ;;
                           
     ort_manuell_function) ort_manuell_function 
                           ;;
                            
 ort_auswahlmenu_function) ort_auswahlmenu_function
                           ;;
                                         
     ort_auswahl_function) ort_auswahl_function $2
                           ;;
                           
            name_function) rm /tmp/phone_out.txt 2>/dev/null
                           name_function ; [ $? = "1" ] && return 1
                           suche_function "$plz" "$ort" "$vorname" "$nachname" ; [ $? = "1" ] && return 1
                           treffer_function
                           if [ -s /tmp/phone_out.txt ] ; then
                             cp /tmp/phone_out.txt $letztesuchliste
                             abfrage_function /tmp/phone_out.txt Namensuche
                           fi
                           ;;
                           
             tel_function) rm /tmp/phone_out.txt 2>/dev/null
                           tel_function  ; [ $? = "1" ] && return 1
                           if [ -s /tmp/phone_out.txt ] ; then
                             cp /tmp/phone_out.txt $letztesuchliste
                             abfrage_function /tmp/phone_out.txt Nummernsuche
                           fi
                           ;;
                            
              letztesuche) abfrage_function $letztesuchliste Letztesuche
                           ;;
                           
esac 




